var Ajv = require('ajv');
var ajv = new Ajv(); // options can be passed, e.g. {allErrors: true}
ajv.addSchema(require('./schemas/signalk.json'), 'signalk')
ajv.addSchema(require('./schemas/vessel.json'), "vessel.json")
ajv.addSchema(require('./schemas/definitions.json'), "definitions.json")
ajv.addSchema(require('./schemas/groups/communication.json'), "communication.json")
ajv.addSchema(require('./schemas/groups/environment.json'), "environment.json")
ajv.addSchema(require('./schemas/groups/navigation.json'), "navigation.json")
ajv.addSchema(require('./schemas/groups/propulsion.json'), "propulsion.json")
ajv.addSchema(require('./schemas/groups/electrical.json'), "electrical.json")
ajv.addSchema(require('./schemas/groups/notifications.json'), "notifications.json")
ajv.addSchema(require('./schemas/groups/steering.json'), "steering.json")
ajv.addSchema(require('./schemas/groups/tanks.json'), "tanks.json")
ajv.addSchema(require('./schemas/groups/design.json'), "design.json")
ajv.addSchema(require('./schemas/groups/sails.json'), "sails.json")
ajv.addSchema(require('./schemas/groups/sensors.json'), "sensors.json")
ajv.addSchema(require('./schemas/groups/performance.json'), "performance.json")
ajv.addSchema(require('./schemas/groups/sources.json'), "sources.json")
ajv.addSchema(require('./schemas/groups/resources.json'), "resources.json")
ajv.addSchema(require('./schemas/external/geojson/geojson.json'), "geojson.json")

var valid = ajv.validate('signalk', require('./test/data/alarms-invalid1.json'));
if (!valid) console.log(ajv.errorsText());
